:- use_module(library(clpb)).

n(D, G, S) :-                 % Gate => Drain = Source
        sat( G*D =:= G*S).

p(D, G, S) :-                 % ~ Gate => Drain = Source
        sat( ~G*D =:= ~G*S).

xor(A, B, Out) :-
        p(1, A, X),                n(B, X, Out),
        n(0, A, X),                p(A, B, Out),
        p(B, A, Out),              n(X, B, Out).

end_of_file.

| ?- n(D, 1, S).                 S = D ?

| ?- n(D, 0, S).                 true ?

| ?- p(D, 0, S).                 S = D ?

| ?- p(D, 1, S).                 true ?

| ?- xor(a, b, X).               sat(X=:=a#b) ?


