% A feladvny:

% Egy szakadkon egy hossz s keskeny pall vel t, amely egyszerre
% legfeljebb kt embert br el. A pall egyik oldaln ll ngy ember: 10, 20,
% 50 s 100 vesek. Az N ves ember N perc alatt tud tmenni a hdon. Ha
% ketten mennek t akkor a lassabb embernek megfelel id alatt rnek t.
% 
% Stt van, vilgts nlkl lehetetlen trni, de a trsasgnak csak
% egyetlen zseblmpja van. A feladat: megszervezni az tkelst gy, hogy a
% teljes trsasg a lehet legrvidebb id alatt tkeljen a
% tloldalra. 
% 
% Krds: mennyi id alatt tudnak leggyorsabban tkelni?

% tmegy(Emberek, N, llapotok, Id): Az Emberek lista tartalmazza az
% tkelni kvn emberek kort (azaz a palln val tmensi idejt).
% A feladvny az adott Emberek listra megoldhat N lpsben Id id alatt,
% s az tmenethez szksges llapotok listja llapotok.
% :- pred tmegy(list(integer)::in, integer::in, list(ll)::out, int::out).
tmegy(Emberek, N, t, Id) :-
	vghelyzet(Emberek, b, Kezdllapot),
	vghelyzet(Emberek, j, Vgsllapot),
	tvonal_4(N, Kezdllapot, Vgsllapot, t, Id).

% Egy llapot tartalmazza annak megadst, hogy a lmpa melyik
% oldalon van (b/j), s az egyes emberek melyik oldalon vannak.

% :- type llapot   ---> lmpahely-list(emberhely).
				% Hol a lmpa s hol vannak az emberek?
% :- type lmpahely ==   oldal.
				% A lmpa az egyik oldalon lehet.
% :- type emberhely ---> ember-oldal.
				% Minden adott kor ember mellett
				% ott a tartzkodsi helye.
% :- type ember     ==   integer.
				% Az embereket a koruk jelli.
% :- type oldal     ---> b ; j. % ball illetve jobb oldal.

% vghelyzet(Emberek, Oldal, llapot): llapot az a vgllapot, amely
% megfelel az Emberek listnak s az Oldal oldalnak.
% :- pred vghelyzet(list(ember)::in, oldal::in, llapot::out).
vghelyzet(Emberek, Oldal, Oldal-Emberhelyek) :-
	prost(Emberek, Oldal, Emberhelyek).


% prost(L0, Y, L): Az L lista elemei X-Y prok,
% ahol X befutja az L listt.
% :- pred prost(list(ember), oldal, list(emberhely)).
prost([], _, []).
prost([X|XL], Y, [X-Y|XYL]) :-
	prost(XL, Y, XYL).

% tszakasz(ll0, ll1, Id): Id alatt az ll0 llapotbl ll1-be lehet jutni.
% :- pred tszakasz(llapot::in, llapot::out, integer::out).
tszakasz(Innen-Helyzet0, Ide-Helyzet, Id) :-
	msik(Innen, Ide),     % A lmpa az Innen oldalon van, Ide a tloldal.
	cserl(E1-Innen, Helyzet0, E1-Ide, Helyzet),       % E1 tmegy
	Id = E1.
tszakasz(Innen-Helyzet0, Ide-Helyzet, Id) :-
	msik(Innen, Ide),
	cserl(E1-Innen, Helyzet0, E1-Ide, Helyzet1),      % E1 tmegy     
	cserl(E2-Innen, Helyzet1, E2-Ide, Helyzet),       % E2 tmegy
	E1 > E2, Id = E1.

% msik(Egyik, Msik): Egyik s Msik kt klnbz oldal.
% :- pred msik(oldal, oldal).
msik(b, j).
msik(j, b).

% cserl(X, XL, Y, YL): egy X elemet XL-ben Y-ra cserlve kapjuk YL-t.
% Deklaratvabban: X ugyanannyiadik eleme XL-nek, mint Y YL-nek, s a kt
% lista csak ebben az elemben klnbzik. 
% :- pred cserl(T, list(T)::in, T, list(T)::out).
% :- pred cserl(T, list(T)::out, T, list(T)::in).
cserl(X, [X|Xlista], Y, [Y|Xlista]).
cserl(X, [Head|Xlista], Y, [Head|Ylista]) :-
	cserl(X, Xlista, Y, Ylista).

:- use_module(library(lists), [member/2, reverse/2]).

% tvonal_4(N, A, B, t, H): A s B kztt van (pontosan)
% N szakaszbl ll krmentes  t tvonal, amelynek sszhossza H.
tvonal_4(N, Honnan, Hov, t, H) :-
        tvonal_4(N, Honnan, Hov,  [Honnan], t, H).

% tvonal_4(N, A, B, K, t, H): A s B kztt van pontosan
% N szakaszbl ll krmentes, K elemein t nem men H hossz  t t.
tvonal_4(0, Hov, Hov,  Kizrtak, t, 0)  :- 
	reverse(Kizrtak, t).
tvonal_4(N, Honnan, Hov, Kizrtak,  t, H) :-
        N > 0, N1 is N-1, 
        tszakasz(Honnan, Kzben, H1),
        \+ member(Kzben, Kizrtak),
        tvonal_4(N1, Kzben, Hov, [Kzben|Kizrtak],  t, H2), 
	H is H1+H2.

end_of_file.

Futsi plda:

$ sicstus
| ?- compile(hid).
% compiling dp_peldak/hid.pl...
%  loading /usr/local/lib/sicstus-3.9.1/library/lists.po...
%  module lists imported into user
%  loaded /usr/local/lib/sicstus-3.9.1/library/lists.po in module lists, 0 msec 11440 bytes
% compiled dp_peldak/hid.pl in module user, 30 msec 15604 bytes
yes
| ?- ensure_loaded(between).
% compiling dp_peldak/between.pl...
% compiled dp_peldak/between.pl in module user, 0 msec 272 bytes
yes
| ?- between(1, 10, N), tmegy([10,20,50,100], N, _t, Id).
N = 5,
Id = 190 ? 
yes
| ?- between(1, 10, N), tmegy([10,20,50,100], N, _t, Id), Id < 190.
N = 5,
Id = 170 ? 
yes
| ?- between(1, 10, N), tmegy([10,20,50,100], N, _t, Id), Id < 170.
no
| ?- between(1, 10, N), tmegy([10,20,50,100], N, _t, Id), Id < 190, 
     (   member(X, _t), write(X), nl, fail
     ;   true
     ).
b-[10-b,20-b,50-b,100-b]
j-[10-j,20-j,50-b,100-b]
b-[10-b,20-j,50-b,100-b]
j-[10-b,20-j,50-j,100-j]
b-[10-b,20-b,50-j,100-j]
j-[10-j,20-j,50-j,100-j]
N = 5,
Id = 170 ? ;
b-[10-b,20-b,50-b,100-b]
j-[10-j,20-j,50-b,100-b]
b-[10-j,20-b,50-b,100-b]
j-[10-j,20-b,50-j,100-j]
b-[10-b,20-b,50-j,100-j]
j-[10-j,20-j,50-j,100-j]
N = 5,
Id = 170 ? ;
no
| ?- 



