:- use_module(library(lists)).

% K egy olyan aritmetikai kifejezs, amelynek rtke E, s
% az L lista sszes elembl a ngy alapmvelettel pl fel.
kif(L, E, K) :-
	fa_levelekbol(L, K),
	E =:= K.

% fa_levelekbol(L, K): K az L lista sszes elembl a ngy
% alapmvelettel pl fel.
fa_levelekbol([K], K).
fa_levelekbol(L, K) :-
	L = [_,_|_],
	L1 = [_|_], L2 = [_|_],
	szetbont(L, L1, L2),
	fa_levelekbol(L1, K1),
	fa_levelekbol(L2, K2),
	epit(K1, K2, K).

% epit(A, B, Kif): Kif A-bl s B-bl a ngy alapmvelet
% egyikvel pl fel.
epit(A, B, A+B).
epit(A, B, A-B).
epit(A, B, A*B).
epit(A, B, A/B).
epit(A, B, AB) :-
	number(A), number(B),
	number_codes(A, As),
	number_codes(B, Bs),
	append(As, Bs, ABs),
	number_codes(AB, ABs).

% szetbont(L, L1, L2): Az L lista az L1 s L2 listk sorrendtart
% sszefslsvel ll el.
szetbont([], [], []).
szetbont([X|L], [X|L1], L2) :-
	szetbont(L, L1, L2).
szetbont([X|L], L1, [X|L2]) :-
	szetbont(L, L1, L2).


