:- use_module(library(clpfd)).

:- op(700, fy, nem).     
:- op(800, yfx, s).     
:- op(900, yfx, vagy).  
:- op(950, xfy, mondja).

A mondja ll :- rtke(A mondja ll, 1).

% rtke(llts, rtk): Az llts igazsgrtke rtk.
rtke(X = Y, E) :-       X in 0..2, Y in 0..2, E #<=> (X #= Y).
rtke(X mondja M, E) :-  X in 0..2, rtke(M, E0), E #<=> (X #= 2 #\/ E0 #= X).
rtke(M1 s M2, E) :-    rtke(M1, E1), rtke(M2, E2), E #<=> E1 #/\ E2.
rtke(M1 vagy M2, E) :-  rtke(M1, E1), rtke(M2, E2), E #<=> E1 #\/ E2.
rtke(nem M, E) :-       rtke(M, E0), E #<=> #\ E0.

end_of_file.

% http://www.math.wayne.edu/~boehm/Probweek2w99sol.htm: We are given three
% people, A, B, C, one of whom is a knight, one a knave, and one a normal
% (but not necessarily in that order). They make the following statements. 
%    A: I am normal, B: A is telling the truth, C: I am not normal 
% What are A, B, and C?

| ?- A mondja A = 2, B mondja A = 2, C mondja nem C =2, all_different([A,B,C]), 
     labeling([], [A,B,C]).
        A = 0, B = 2, C = 1 ? ; no
