:- use_module(library(clpfd)).

% A Qs lista N kirlyn biztonsgos elhelyezst mutatja egy N*N-es sakktbln: 
% a lista i. eleme j ===> az i. kirlynt az i. sor j. oszlopba kell helyezni.
queens(N, Qs):-           length(Qs, N), domain(Qs, 1, N), safe(Qs).

% safe(Qs): A Qs kirlyn-lista biztonsgos.
safe([]).
safe([Q|Qs]):-            no_attack(Qs, Q, 1), safe(Qs).

% no_attack(Qs, Q, I): A Qs lista ltal lert kirlynk egyike sem tmadja a 
% Q oszlopban lev kirlynt, feltve hogy Q s Qs tvolsga I.

no_attack([],_,_).
no_attack([X|Xs], Y, I):- no_threat(X, Y, I), J is I+1, no_attack(Xs, Y, J).

% Az X s Y oszlopokban  I sortvolsgra lev kirlynk nem tmadjk egymst.
no_threat(X, Y, I) :-     Y #\= X, Y #\= X-I, Y #\= X+I.

end_of_file.

| ?- queens(4, Qs).
        Qs = [_A,_B,_C,_D], _A in 1..4, _B in 1..4, _C in 1..4, _D in 1..4 ? 
| ?- queens(4, Qs), Qs = [1|_].
        Qs = [1,_A,_B,_C], _A in 3..4, _B in{2}\/{4}, _C in 2..3 ? 
| ?- queens(4, Qs), Qs = [1|_], labeling([], Qs).
        no
| ?- queens(4, Qs), Qs = [2|_], labeling([], Qs).
        Qs = [2,4,1,3] ? 
