% szm(Szm, Alap, Jk): A Szm szm Alap alap szmrendszerben vett 
% jegyeinek (balrl jobbra halad) listja Jk. (A 0 szm egy jegybl ll.)
szm(0, _, [0]).
szm(Sz, Alap, Jk) :-
        Sz > 0, szm(Sz, Alap, [], Jk).

% szm(Szm, Alap, Jk0, Jk): A Szm szm Alap alap szmrendszerben vett
% jegyeinek listjt Jk0 el fzve kapjuk Jk-t (A 0 jegylistja res). 
% Jells:  LL = L-L0 <----> az LL listt L0 el fzve kapjuk L-t.
szm(0, _, Jk, Jk).
szm(Sz, Alap, Jk0, Jk) :-
        Sz > 0, Sz1 is Sz//Alap, UtsoJegy is Sz mod Alap,
        szm(Sz1, Alap, [UtsoJegy|Jk0], Jk).

% fszm(Sz, A, Jk): Az Sz szm A alap fordtott jegylistja Jk.
fszm(0, _, [0]).
fszm(Sz, Alap, Jk) :-
	Sz > 0, fszm(Sz, Alap, [], Jk).

% fszm(Sz, A, Jk0, Jk): Az Sz szm A alap fordtott jegylistja Jk-Jk0.
fszm(0, _, Jk, Jk).
fszm(Sz, Alap, Jk0, [UtsoJegy|Jk]) :-
        Sz > 0, Sz1 is Sz//Alap, UtsoJegy is Sz mod Alap,
        fszm(Sz1, Alap, Jk0, Jk).

% fszm(Szm, Alap, Jegyek): A Szm >= 0 szm  Alap > 1 alap
% szmrendszerben jobbrl balra vett jegyeinek listja Jegyek.
fszm1(0, _, [0]).
fszm1(Sz, Alap, Jk) :-
        Sz > 0, fszm12(Sz, Alap, Jk).

% fszm12(Szm, Alap, Jk): A Szm >= 0 szm Alap > 1 alap
% szmrendszerben jobbrl balra vett jegyeinek listja Jk.
fszm12(0, _, []).
fszm12(Sz, Alap, [UtsoJegy|Jk]) :-
        Sz > 0, Sz1 is Sz//Alap, UtsoJegy is Sz mod Alap,
        fszm12(Sz1, Alap, Jk).
